###################################################
### chunk number 1: setup
###################################################
#line 113 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"

require(CHNOSZ)

options(width=65,continue=" ")



###################################################
### chunk number 2: SolveFour
###################################################
#line 241 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
A <- matrix(c(2,2,1,1, 0,1,0,0, 0,0,1,0, 0,0,0,1), 4)
b <- c(88.3,110.6,62.2,40.56)
x <- solve(A,b)
names(x) <- c("CH3","CH2","CH2OH","COOH")
x


###################################################
### chunk number 3: CpAmendHelgeson
###################################################
#line 251 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
Cp.AH97 <- c(CH3=47.00,CH2=20.70,CH2OH=17.28,COOH=-5.94,CHCH3=39.92)
Cp.AH97


###################################################
### chunk number 4: BigMatrixAdd
###################################################
#line 280 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
# xtable for making nice LaTeX tables
require(xtable)
# read the "big group" specification
f <- system.file("extdata/thermo/groups_big.csv",package="CHNOSZ")
A.big <- read.csv(f,check.names=FALSE,row.names=1)
# only take selected rows
imod <- c("ethane","propane","butane","ethanol","1-propanol","1-butanol","1-pentanol",
  "acetone","butanone","3-pentanone","2-heptanone",
  "acetic acid","propanoic acid","butanoic acid")
A.big <- A.big[imod,]
# get the heat capacities
is1 <- info(rownames(A.big),quiet=TRUE)
mydf <- data.frame(Cp=info(is1,quiet=TRUE)$Cp,A.big,check.names=FALSE)
print(xtable(mydf,align=c("l","r","r","r","r","r","r")))


###################################################
### chunk number 5: QRexample
###################################################
#line 301 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
set.seed(24)
print(A <- matrix(runif(12), 4))
b <- 1:4
x <- qr.solve(A,b)
as.numeric(A %*% x)


###################################################
### chunk number 6: ReadBigAdd
###################################################
#line 326 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
file.big <- system.file("extdata/thermo/groups_big.csv",package="CHNOSZ")
A.big <- read.csv(file.big,check.names=FALSE,row.names=1)
iuse <- c("ethane","propane","butane","ethanol","1-propanol","1-butanol","1-pentanol",
  "acetone","butanone","3-pentanone","2-heptanone",
  "acetic acid","propanoic acid","butanoic acid")
A.big <- A.big[iuse,]
A.big[is.na(A.big)] <- 0


###################################################
### chunk number 7: CpSpeciesAdd
###################################################
#line 338 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
ispecies <- info(rownames(A.big),quiet=TRUE)
cp.species <- info(ispecies)$Cp


###################################################
### chunk number 8: SolveBigAdd
###################################################
#line 363 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
cp.big <- qr.solve(A.big,cp.species)
cp.big


###################################################
### chunk number 9: RMSDBigAdd
###################################################
#line 370 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
pred.big <- as.matrix(A.big) %*% cp.big
rmsd <- rmsd(pred.big,cp.species)
rmsd


###################################################
### chunk number 10: ResidualsBigAdd eval=FALSE
###################################################
## #line 378 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
## residuals <- pred.big - cp.species
## names(residuals) <- rownames(A.big)
## residuals <- residuals
## residualsplot(residuals,"Cp","big groups (added)")


###################################################
### chunk number 11: ResidualsPlotBigAdd
###################################################
#line 411 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
residuals <- pred.big - cp.species
names(residuals) <- rownames(A.big)
residuals <- residuals
residualsplot(residuals,"Cp","big groups")


###################################################
### chunk number 12: BigMatrixSub
###################################################
#line 439 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
# xtable for making nice LaTeX tables
require(xtable)
# read the "big group" specification
f <- system.file("extdata/thermo/groups_big.csv",package="CHNOSZ")
A.big <- read.csv(f,check.names=FALSE,row.names=1)
# get the heat capacities
is1 <- info(rownames(A.big),quiet=TRUE)
mydf <- data.frame(Cp=info(is1,quiet=TRUE)$Cp,A.big,check.names=FALSE)
rownames(mydf) <- paste(paste("(",1:nrow(mydf),")",sep=""),rownames(mydf))
print(xtable(mydf,align=c("l","r","r","r","r","r","r")))


###################################################
### chunk number 13: ReadBigSub
###################################################
#line 456 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
file.big <- system.file("extdata/thermo/groups_big.csv",package="CHNOSZ")
A.big <- read.csv(file.big,check.names=FALSE,row.names=1)
A.big[is.na(A.big)] <- 0


###################################################
### chunk number 14: CpBigSub
###################################################
#line 464 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
ispecies <- info(rownames(A.big),quiet=TRUE)
cp.species <- info(ispecies,quiet=TRUE)$Cp


###################################################
### chunk number 15: SolveBigSub
###################################################
#line 471 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
i.big <- 1:24
cp.big <- qr.solve(A.big[i.big,],cp.species[i.big])
cp.big


###################################################
### chunk number 16: RMSDBigSub
###################################################
#line 479 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
pred.big <- as.matrix(A.big) %*% cp.big
rmsd <- rmsd(pred.big[i.big],cp.species[i.big])
rmsd


###################################################
### chunk number 17: ResidualsBigSub eval=FALSE
###################################################
## #line 487 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
## residuals <- pred.big - cp.species
## names(residuals) <- rownames(A.big)
## residuals <- residuals[i.big]
## residualsplot(residuals,"Cp","big groups")


###################################################
### chunk number 18: ResidualsPlotBigSub
###################################################
#line 525 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
residuals <- pred.big - cp.species
names(residuals) <- rownames(A.big)
residuals <- residuals[i.big]
residualsplot(residuals,"Cp","big groups")


###################################################
### chunk number 19: SmallMatrix
###################################################
#line 603 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
# read the "small group" specification
file.small <- system.file("extdata/thermo/groups_small.csv",package="CHNOSZ")
A.small <- read.csv(file.small,check.names=FALSE,row.names=1)
# add stars to indicate species from Aug.11
ispecies <- info(head(rownames(A.small),-1),quiet=TRUE)
inew <- grep("Aug.11",info(ispecies,quiet=TRUE)$date)
row.names(A.small)[inew] <- paste(row.names(A.small)[inew],"*")
xt <- xtable(A.small,align=c("p{4.5cm}",rep("p{0.6cm}",12)))
# now perform some work on the LaTeX code to rotate the column names
xp <- capture.output(print(xt))
# column names are in line 7
stuff <- xp[[7]]
# remove the \\\\ at end
stuff <- strsplit(stuff,"\\\\\\\\ ")[[1]]
# split the text at the latex separator
stuff <- strsplit(stuff,"& ")[[1]]
# remove the separating spaces
stuff <- gsub("\ $","",stuff)
# remember which ones are blank
iblank <- stuff==""
# add the latex rotation instructions
# have to escape the backslash
stuff <- paste("\\rotatebox{60}{",stuff,"}",sep="")
# restore the blanks
stuff[iblank] <- ""
# restore the separating latex separator character
stuff <- list(paste(stuff,"& "))
# unsplit it
stuff <- sapply(stuff,paste,collapse="")
# restore the \\\\ at end
stuff <- gsub("& $","\\\\\\\\ ",stuff)
# put in our modified code for column names
xp[[7]] <- stuff
cat(xp,sep="\n")


###################################################
### chunk number 20: ReadSmall
###################################################
#line 644 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
file.small <- system.file("extdata/thermo/groups_small.csv",package="CHNOSZ")
A.small <- read.csv(file.small,check.names=FALSE,row.names=1)
A.small[is.na(A.small)] <- 0


###################################################
### chunk number 21: CpSpeciesSmall
###################################################
#line 652 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
ispecies <- info(head(rownames(A.small),-1),quiet=TRUE)
cp.species <- info(ispecies,quiet=TRUE)$Cp
cp.species <- c(cp.species,NA)


###################################################
### chunk number 22: SolveSmall
###################################################
#line 660 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
i.small <- 1:24
cp.small <- qr.solve(A.small[i.small,],cp.species[i.small])
cp.small


###################################################
### chunk number 23: RMSDSmall
###################################################
#line 688 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
pred.small <- as.matrix(A.small) %*% cp.small
rmsd <- rmsd(pred.small[i.small],cp.species[i.small])
rmsd


###################################################
### chunk number 24: ResidualsSmall eval=FALSE
###################################################
## #line 696 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
## residuals <- pred.small - cp.species
## names(residuals) <- rownames(A.small)
## residuals <- residuals[i.small]
## residualsplot(residuals,"Cp","small groups")


###################################################
### chunk number 25: ResidualsPlotSmall
###################################################
#line 725 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
residuals <- pred.small - cp.species
names(residuals) <- rownames(A.small)
residuals <- residuals[i.small]
residualsplot(residuals,"Cp","small groups")


###################################################
### chunk number 26: LacCit
###################################################
#line 751 "d:/Rcompile/CRANpkg/local/2.12/CHNOSZ/inst/doc/xadditivity.Rnw"
ilac <- match("lactic acid",rownames(A.small))
icit <- match("citric acid",rownames(A.small))
iiso <- match("isocitric acid",rownames(A.small))
pb <- round(pred.big,2)
ps <- round(pred.small,2)


